*******************
* fvwribb.prg
********************
* Hauptfenster
************************************************
* Version 2.00.001   16.10.2014
*
************************************************
#include "inkey.ch"
#include "Xbp.ch"
#include "AppEvent.ch"
#include "dcdialog.ch"
#include "foxdbe.ch"
#include "cdxdbe.ch"
#include "dbfdbe.ch"
#include "dcmsg.ch"

#Pragma Library("xbtbase1.lib")
#Pragma Library("xbtbase2.lib")

#define GRA_CLR_HIGHLIGHT     GraMakeRGBColor({255,204,153})
#define GRA_CLR_BG_BLAU       GraMakeRGBColor({165,195,243})

#define ICJ_END           11106
#define TB_EXCEL        10300
#define TB_DOC          10301
#define TB_PDF          10302
#define TB_NURPRINT     10303
#define TB_EMAIL        10304
#define TB_HELP         10305

#define P_STANDARD  1
#define P_VORSCHAU  2
#define P_AUSWAHL   3
#define FS_ABBRUCH     -1


****************************************************************************
**********************************************************************
PROCEDURE Dbesys()

IF !DbeLoad( "DBFDBE",.T.)
   DC_WinAlert( "Database-Engine DBFDBE not loaded" )
ENDIF
IF !DbeLoad( "CDXDBE",.T.)
   DC_WinAlert( "Database-Engine CDXDBE not loaded"  )
ENDIF
IF ! DbeLoad( "FOXDBE",.T.)
   DC_WinAlert("Database engine FOXDBE not loaded")
ENDIF
IF !DbeBuild( "FOXCDX", "FOXDBE", "CDXDBE" )
   DC_WinAlert("Database engine FOXCDX not created")
ELSE
   DbeSetDefault("FOXCDX")
   DbeInfo(COMPONENT_ORDER,FOXDBE_LOCKRETRY,20000000)
   DbeInfo(COMPONENT_ORDER,FOXDBE_LOCKDELAY,10)
   DbeInfo(COMPONENT_ORDER, FOXDBE_LOCKMODE, LOCKING_EXTENDED)
   DbeInfo(COMPONENT_ORDER, FOXDBE_LIFETIME, 0)
ENDIF
RETURN
*********************************
PROC appsys ; RETURN
****************************************************************************
PROCEDURE Main()
local GetOptions

SET COLLATION TO GERMAN
set date german
set century on
set epoch to 1990
set wrap off
set deleted on
set optimize off
set rushmore off
set smartfilter off
SetCancel(.F.)

DC_LangSet(DCLANG_GERMAN)
DC_PopDateStart(.T.)
DC_GetPopupCaption( {"10.Marlett", "u", 1 } )
DC_Gui(.T.)
DC_DotHotkey(0)
DC_BitmapTransparentColor( {191,191,191})

DC_SetIconResource(10300,11106)

DCGET OPTIONS ;
   SAYWIDTH 190 ;
   SAYHEIGHT 28 ;
   SAYOPTIONS XBPSTATIC_TEXT_VCENTER ;
   FONT "11.Arial Fett" ;
   SAYFONT "11.Arial Fett" ;
   GETFONT "14.Courier New" ;
   GETHEIGHT 10 ;
   ROWPIXELS 28 ;
   ROWSPACE 28 ;
   COLPIXELS 10 ;
   TABSTOP ;
   CHECKGET ;
   COLOR 32752549 ;
   PRESENTATION { { XBP_PP_DISABLED_FGCLR,GRA_CLR_BLACK}, { XBP_PP_DISABLED_BGCLR,32752549}}

dc_getoptdefault(GetOptions)


*DC_EmulatePre265(.T.)

****************
*Test()
*DruckStdDialog("Test Print", "MyPrinter", 1, "")
Test2()
****************
return
***********************************************************************************************************
procedure test()
LOCAL GetList:={}
*local aSizeDesktop:=AppDesktop():currentSize()
*, area:=dc_GetWorkArea()
local oTagbox, oGrp, oIcon
local aufnum:=1234567, lfsnum:=987654, ctitle:=space(10)
local icon_size:=48
local icon:=ICJ_END
local nOffset:=icon_size+2
local cFont:="9.Arial"
local oBtnConf:=ButtonConfig()

@1.0, 1 DCSTATIC TYPE XBPSTATIC_TYPE_RECESSEDBOX SIZE 100,5.0 OBJECT oTagBox

@1.8, 1 DCSAY "Number1 :" SAYSIZE 9.44 PARENT oTagBox
@1.8,11 DCSAY {|| str(aufnum,7) } ;
        PRESENTATION { { XBP_PP_FGCLR, GRA_CLR_BLACK },{ XBP_PP_BGCLR, GRA_CLR_WHITE } } ;
        PARENT oTagBox ;
        SAYSIZE 7.00,0.8

@2.9, 1 DCSAY "Number 2:" SAYSIZE 9.44 PARENT oTagBox
@2.9,11 DCSAY {|| str(lfsnum,7) } ;
       COLOR GRA_CLR_BLACK, GRA_CLR_WHITE ;
       PARENT oTagBox ;
       SAYSIZE 7.00,0.8

@7.0, 1 DCGROUP oGrp CAPTION " Group " SIZE 50.50,5

@8.2, 2 DCSAY "Title:" SAYSIZE 4
@8.7,11 DCGET ctitle PICTURE "!XXXXXXXXX"

oIcon := XbpIcon():New():Create()
oIcon:Load(,icon,icon_size,icon_size)

@240,600 DCPUSHBUTTONXP SIZE 180,42.5 ;
                 CAPTION "Buttonexample (Exit)" OFFSET nOffset ;
                 BITMAP oIcon ALIGN XBPALIGN_VCENTER+XBPALIGN_LEFT OFFSET 5 ;
                 CONFIG oBtnConf ;
                 FONT cFont ;
                 ACTION {|| DC_ReadGuiEvent(DCGUI_EXIT_OK,GetList) } ;
                 RESIZE DCGUI_RESIZE_AUTORESIZE ;
                 PIXEL

DCREAD GUI ;
   TITLE "Test eXPress 265" ;
   FIT ;

RETURN
*************************************************
function ButtonConfig()
local oBtnConf1:= DC_XbpPushButtonXPConfig():new()

oBtnConf1:fgColor :=GRA_CLR_BLACK
oBtnConf1:bgColor :=GraMakeRGBColor({255,255,233})
oBtnConf1:fgColorClick := 16777216
oBtnConf1:bgColorClick :=  20158975
oBtnConf1:fgColorMouse := GRA_CLR_BLACK
oBtnConf1:bgColorMouse := GRA_CLR_HIGHLIGHT
oBtnConf1:gradientStep := 0
oBtnConf1:gradientStyle := 2
oBtnConf1:radius := 15
oBtnConf1:gradientReverse := .F.
oBtnConf1:outline := .T.
oBtnConf1:mouseOverFont := nil
oBtnConf1:mouseOverScale := 1.0
oBtnConf1:bitmapScale := 1.0
oBtnConf1:borderColor := GRA_CLR_WHITE
oBtnConf1:disabledFGColor := 26646166
oBtnConf1:disabledBGColor := 31251676
oBtnConf1:disabledBmp := .T.
oBtnConf1:enableSelect := .F.
oBtnConf1:mouseOverSound := nil
oBtnConf1:tileBitMap := nil
oBtnConf1:menuButtonWidth := 15
oBtnConf1:alignCaption := 5
oBtnConf1:alignBitmap := XBPALIGN_TOP+XBPALIGN_HCENTER
oBtnConf1:focusRectStyle := 0
oBtnConf1:focusRectColor := 1
oBtnConf1:isBitmapBackground := .t.
oBtnConf1:font := "9.Arial"
oBtnConf1:bgColor :=GRA_CLR_BG_BLAU
oBtnConf1:borderColor :=GRA_CLR_BG_BLAU
oBtnConf1:disabledBGColor :=GRA_CLR_BG_BLAU
return oBtnConf1
**************************************************************************************
function DruckStdDialog(PrtTitel, druname, anzexempl, extform)
local Getlist:={}, GetOptions, retw:=0, cTxt:="", lAusw:=.F., lExit
local oStd, oVor, oAus, oGroup
local aCap1, aCap2, aCap3
local bigfont:="12. Arial"
local stdfont:="10.Arial"
local smallfont:="8.Arial"
local cLText:=""

DCGET OPTIONS NOMINBUTTON NOMAXBUTTON

@ 1,1 DCGROUP oGroup CAPTION ' Ausgabeauswahl ' SIZE 380,290 PIXEL

if extform=="XLS"
   aCap1 := {{ DC_GetBitMap(TB_EXCEL),, 15,15,60,60,,,}, ;
          { 'Standarddrucker', GRA_CLR_BLACK, 25, 80,,,,bigfont,,}, ;
          { "Export nach Excel", GRA_CLR_BLACK, 75, 80,,,,stdfont,,}, ;
          { "", GRA_CLR_BLACK, 120, 80,,,,smallfont,,} }
elseif extform=="TXT"
   aCap1 := {{ DC_GetBitMap(TB_DOC),, 15,15,60,60,,,}, ;
          { 'Standarddrucker', GRA_CLR_BLACK, 25, 80,,,,bigfont,,}, ;
          { "Export in TXT-Datei", GRA_CLR_BLACK, 75, 80,,,,stdfont,,}, ;
          { "", GRA_CLR_BLACK, 120, 80,,,,smallfont,,} }
elseif extform=="PDF"
   aCap1 := {{ DC_GetBitMap(TB_PDF),, 15,15,60,60,,,}, ;
          { 'Standarddrucker', GRA_CLR_BLACK, 25, 80,,,,bigfont,,}, ;
          { "Export in PDF-Datei", GRA_CLR_BLACK, 75, 80,,,,stdfont,,}, ;
          { "", GRA_CLR_BLACK, 120, 80,,,,smallfont,,} }
elseif empty(cTxt)
   aCap1 := {{ DC_GetBitMap(TB_NURPRINT),, 15,15,60,60,,,}, ;
          { 'Standarddrucker', GRA_CLR_BLACK, 25, 80,,,,bigfont,,}, ;
          { alltrim(druname), GRA_CLR_BLACK, 75, 80,,,,stdfont,,}, ;
          { cLText+"Exemplare: "+alltrim(str(anzexempl)), GRA_CLR_BLACK, 120, 80,,,,smallfont,,} }
else
   aCap1 := {{ DC_GetBitMap(TB_NURPRINT),, 15,15,60,60,,,}, ;
          { 'Standarddrucker', GRA_CLR_BLACK, 20, 80,,,,bigfont,,}, ;
          { alltrim(druname), GRA_CLR_BLACK, 60, 80,,,,stdfont,,}, ;
          { clText+"Exemplare: "+alltrim(str(anzexempl)), GRA_CLR_BLACK, 100, 80,,,,smallfont,,}, ;
          { cTxt, GRA_CLR_BLACK, 130, 80,,,,'10.Arial',,} }
endif

@20,10 DCPUSHBUTTONXP SIZE 360,80 ;
        CAPTIONARRAY aCap1 ;
        PARENT oGroup ;
        PIXEL ;
        OBJECT oStd ;
        CONFIG ButtonConfig() ;
        ACTION {|| retw:=P_STANDARD, DC_ReadGuiEvent(DCGUI_EXIT_OK,Getlist) } ;
        WHEN {|| lAusw }

@104,10 DCSTATIC TYPE XBPSTATIC_TYPE_RECESSEDBOX SIZE 360,2 PARENT oGroup PIXEL

aCap2 := {{ DC_GetBitMap(TB_PDF),, 15,15,60,60,,,}, ;
          { 'Vorschau', GRA_CLR_BLACK, 25, 80,,,,bigfont,,}, ;
          { "Vorschau", GRA_CLR_BLACK, 75, 80,,,,stdfont,,}, ;
          { "Mit Logo", GRA_CLR_BLACK, 120, 80,,,,smallfont,,} }

@110,10 DCPUSHBUTTONXP SIZE 360,80 ;
        CAPTIONARRAY aCap2 ;
        PARENT oGroup ;
        PIXEL ;
        OBJECT oVor ;
        CONFIG ButtonConfig() ;
        ACTION {|| retw:=P_VORSCHAU, DC_ReadGuiEvent(DCGUI_EXIT_OK,Getlist) }

@194,10 DCSTATIC TYPE XBPSTATIC_TYPE_RECESSEDBOX SIZE 360,2 PARENT oGroup PIXEL

aCap3 := {{ DC_GetBitMap(TB_HELP),, 15,15,60,60,,,}, ;
          { 'Druckerauswahl', GRA_CLR_BLACK, 25, 80,,,,bigfont,,}, ;
          { "Whlen Sie den Drucker aus.", GRA_CLR_BLACK, 110, 80,,,,stdfont,,} }

@200,10 DCPUSHBUTTONXP SIZE 360,80 ;
        CAPTIONARRAY aCap3 ;
        PARENT oGroup ;
        PIXEL ;
        OBJECT oAus ;
        CONFIG ButtonConfig() ;
        ACTION {|| retw:=P_AUSWAHL, DC_ReadGuiEvent(DCGUI_EXIT_OK,Getlist) }

DCREAD GUI;
   TO lExit ;
   TITLE substr(PrtTitel,1,46) ;
   OPTIONS GetOptions ;
   FIT;
   MODAL ;
   SETAPPWINDOW ;
   EVAL {|o| SetAppFocus(o), SetAppFocus(iif(lAusw, oStd, oAus)) }


if !lExit
   retw:=FS_ABBRUCH
endif
return retw
*************************************************************************
procedure test2()
LOCAL GetList:={}, GetOptions, oWaaMainWin
local oANr, oAT1, oMen
local v_artnum:=padright("123",15)
local v_artname1:=padright("Test",35), v_artname2:=space(35)
local v_menge:=0


DCGET OPTIONS ;
      CHECKGET ;
      NOSUPERVISE


@ 2.85, 2.00 DCSAY "Artikel-Nr."
@ 4.85, 2.00 DCGET v_artnum ;
       PICT "!!!!!!!!!!!!!!!" ;
       GETOBJECT oANr ;
       TABGROUP XBP_BEGIN_GROUP

@ 2.85,24.00 DCSAY "Bezeichnung"
@ 4.85,24.00 DCGET v_artname1 ;
       PICT "XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX" ;
       GETOBJECT oAT1 ;
       TABSTOP ;
       TABGROUP XBP_WITHIN_GROUP

@ 6.85,24.00 DCGET v_artname2 ;
       PICT "XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX" ;
       TABGROUP XBP_WITHIN_GROUP

@ 6.85,71 DCSAY "Menge"
@ 8.85,71 DCGET v_menge ;
       PICT "999.999" ;
       GETOBJECT oMen ;
       TABSTOP ;
       TABGROUP XBP_WITHIN_GROUP ;
       POPUP {|| nil } ;
       POPCAPTION "+" POPFONT "12.Arial" POPSTYLE DCGUI_POPUPSTYLE_IMBEDDED ;
       POPKEY xbeK_F1

@12.3,80.00 DCPUSHBUTTON CAPTION "~Ok" ;
       SIZE 15.00,1.20 ;
       ACTION {|| iif(v_menge=0, v_menge:=12, iif(v_menge=12, v_menge:=122, nil)), Dc_getrefresh(Getlist), SetAppFocus(oANr) } ;
       TABGROUP XBP_END_GROUP ;
       TABSTOP ;
       ACCELKEY xbeK_ALT_S

@12.3,96.00 DCPUSHBUTTON CAPTION "~End" ;
       SIZE 15.00,1.20 ;
       ACTION {|| DC_ReadGuiEvent(DCGUI_EXIT_ABORT,Getlist) } ;
       TABGROUP XBP_WITHIN_GROUP ;
       TABSTOP

@14,1.00 DCSAY "Xbase++ Version "+version(1)+"."+version(2)+"."+version(3)+", (c) Alaska Software" SAYSIZE 36.00 COLOR GRA_CLR_DARKBLUE
@15,1.00 DCSAY "eXPress++ Version "+dc_versionexpress(1)+"."+dc_versionexpress(2)+" Build "+dc_versionexpress(3)+", (c) Donnay Software" SAYSIZE 36.00 COLOR GRA_CLR_DARKBLUE


DCREAD GUI ;
   TITLE "Test2" ;
   OPTIONS GetOptions ;
   PARENT @oWaaMainWin ;
   CLEAREVENTS ;
   SETAPPWINDOW ;
   FIT
return